/**
 * @file jvmData.h
 */
#ifndef JVM_DATA_H
#define JVM_DATA_H

long debugger(void);
void writeJavaByte(long address, long value);
long readJavaByte(long address);
void writeJavaIntBE(long address, long value);
long readJavaIntBE(long address);
void init(long jprog, long jsize, long port);
long getLdc(long index);
long getStatic(long offset);
void putStatic(long offset, long value);
void eeBlockWrite(long address);
void eeWriteByte(long address, long value);
long eeReadByte(long address);
long getEndLoad(void);
long getMemSize(void);
long getProgSize(void);
long getHeapBase(void);
void setMustDoStep(void);
void clearMustDoStep(void);
long mustStep(void);
void setNotifyStepDone(void);
void clearNotifyStepDone(void);
long mustNotifyStepDone(void);
void setCarry(void);
void clearCarry(void);
long isCarry(void);
void setJvmEP(long ep);
long getJvmEP(void);
void setJvmHP(long hp);
long getJvmHP(void);
void setJvmSP(long sp);
long getJvmSP(void);
void setJvmSB(long sb);
long getJvmSB(void);
void setJvmFP(long fp);
long getJvmFP(void);
void setJvmPC(long pc);
long getJvmPC(void);
void incJvmPC(long value);   
void setJvmMP(long mp);
long getJvmMP(void);
void setActivity(long kActivity);
long getActivity(void);
void setBreakpointByte(long index, long value);
void setBreakpoints(long value);
long isBreakpoint(void);
void writeJVMregister(long address, long value);
long readJVMregister(long address);

#endif