/**
 * @file jvmEeprom.h
 */
#ifndef JVM_EEPROM_H
#define JVM_EEPROM_H

// 24LC256 EEPROM constants

#define SDA  29  // P29 = data line
#define SCL  28  // P28 = clock line
#define ACK   0  // Acknowledge bit = 0
#define NACK  1  // (No) acknowledge bit = 1
  
static void SendAck(long ackbit);
static long GetAck(void);
static void I2cStart(void);
static void I2cStop(void);
static long GetByte(void);
static long SendByte(long b);
static void Poll(void);
static void SetAddr(long addr);
void FromRam(long startAddr, long endAddr, long eeStart);  
void ToRam(long startAddr, long endAddr, long eeStart);
void VarBackup(long startAddr, long endAddr);
void VarRestore(long startAddr, long endAddr);

#endif