/**
 * @file jvmEngine.h
 */
#ifndef JVM_ENGINE_H
#define JVM_ENGINE_H

//first 64
#define  Jem_NOP               0x00
#define  Jem_ICONST_M1         0x01
#define  Jem_ICONST_0          0x02
#define  Jem_ICONST_1          0x03
#define  Jem_ICONST_2          0x04
#define  Jem_ICONST_3          0x05
#define  Jem_ICONST_4          0x06
#define  Jem_ICONST_5          0x07
#define  Jem_BIPUSH            0x08
#define  Jem_SIPUSH            0x09
#define  Jem_ILOAD             0x0A
#define  Jem_ILOAD_0           0x0B
#define  Jem_ILOAD_1           0x0C
#define  Jem_ILOAD_2           0x0D
#define  Jem_ILOAD_3           0x0E
#define  Jem_ISTORE            0x0F
#define  Jem_ISTORE_0          0x10
#define  Jem_ISTORE_1          0x11
#define  Jem_ISTORE_2          0x12
#define  Jem_ISTORE_3          0x13
#define  Jem_IFEQ              0x14
#define  Jem_IFNE              0x15
#define  Jem_IFLT              0x16
#define  Jem_IFLE              0x17
#define  Jem_IFGT              0x18
#define  Jem_IFGE              0x19
#define  Jem_IF_ICMPEQ         0x1A
#define  Jem_IF_ICMPNE         0x1B
#define  Jem_IF_ICMPLT         0x1C
#define  Jem_IF_ICMPGE         0x1D
#define  Jem_IF_ICMPGT         0x1E
#define  Jem_IF_ICMPLE         0x1F
#define  Jem_IF_ACMPEQ         0x20
#define  Jem_IF_ACMPNE         0x21
#define  Jem_IRETURN           0x22
#define  Jem_RETURN            0x23
#define  Jem_INVOKEVIRTUAL     0x24
#define  Jem_INVOKESTATIC      0x25
#define  Jem_GETSTATIC         0x26
#define  Jem_PUTSTATIC         0x27
#define  Jem_POP               0x28
#define  Jem_POP2              0x29
#define  Jem_DUP               0x2A
#define  Jem_DUP_X1            0x2B
#define  Jem_DUP_X2            0x2C
#define  Jem_DUP2              0x2D
#define  Jem_DUP2_X1           0x2E
#define  Jem_DUP2_X2           0x2F
#define  Jem_SWAP              0x30
#define  Jem_IADD              0x31
#define  Jem_ISUB              0x32
#define  Jem_INEG              0x33
#define  Jem_IOR               0x35
#define  Jem_ISHL              0x37
#define  Jem_ISHR              0x39
#define  Jem_IUSHR             0x3B
#define  Jem_IAND              0x3D
#define  Jem_IXOR              0x3F
#define  Jem_I2B               0x41
#define  Jem_GOTO              0x43
#define  Jem_INVOKEINTERFACE   0x45
#define  Jem_ARRAYLENGTH       0x47
#define  Jem_ATHROW            0x49
#define  Jem_CHECKCAST         0x4B
//next 64
#define  Jem_INSTANCEOF        0x4D
#define  Jem_WIDE              0x4F
#define  Jem_IINC              0x51
#define  Jem_GETFIELD          0x53
#define  Jem_PUTFIELD          0x55
#define  Jem_NEW               0x57
#define  Jem_NEWARRAY          0x59
#define  Jem_ANEWARRAY         0x5B
#define  Jem_IALOAD            0x5D
#define  Jem_IASTORE           0x5F
#define  Jem_BALOAD            0x61
#define  Jem_BASTORE           0x63
#define  Jem_LDC               0x65
#define  Jem_LDC_W             0x67
#define  Jem_LDC_W2            0x69
#define  Jem_IMUL              0x6B
#define  Jem_IDIV              0x6D
#define  Jem_IREM              0x6F
#define  Jem_JSR               0x71
#define  Jem_RET               0x73
#define  Jem_TABLESWITCH       0x75
#define  Jem_LOOKUPSWITCH      0x77

long doStep(void);
long doBytecode(void);

#endif