/*
********************************************************
* File jvmLoad: loading local variables onto the stack *
********************************************************
*/


#include "jvmStack.h"
#include "jvmData.h"
#include "jvmLoad.h"
  
void jb_iload(void) {
  long fp,index,val;
/* Meaning: Load integer from local variable. */
/*
  JEM format: iload,byte1
  byte1 is the index of the local variable.
*/
  index = readJavaByte(getJvmPC()+1);
  fp = getJvmFP();
  val = readJavaIntBE(fp + (index<<1));
  push(val);
  incJvmPC(2);
}  

void jb_iload_0(void) {
  long fp,val;
/* Meaning: Load integer from local variable with index 0. */
/*
  JEM format: iload_0
*/
  fp = getJvmFP();
  val = readJavaIntBE(fp);
  push(val);
  incJvmPC(1);
}  

void jb_iload_1(void) {
  long fp,val;
/* Meaning: Load integer from local variable with index 1. */
/*
  JEM format: iload_1
*/
  fp = getJvmFP();
  val = readJavaIntBE(fp + 2);
  push(val);
  incJvmPC(1);
}

void jb_iload_2(void) {
  long fp,val;
/* Meaning: Load integer from local variable with index 2. */
/*
  JEM format: iload_2
*/
  fp = getJvmFP();
  val = readJavaIntBE(fp + 4);
  push(val);
  incJvmPC(1);
}

void jb_iload_3(void) {
  long fp,val;
/* Meaning: Load integer from local variable with index 3. */
/*
  JEM format: iload_3
*/
  fp = getJvmFP();
  val = readJavaIntBE(fp + 6);
  push(val);
  incJvmPC(1);
}

/*PUB jb_lload*/
/* Meaning: Load long integer from local variable. */


/*PUB jb_lload_0*/
/* Meaning: Load long integer from local variable with index 0. */


/*PUB jb_lload_1*/
/* Meaning: Load long integer from local variable with index 1. */


/*PUB jb_lload_2*/
/* Meaning: Load long integer from local variable with index 2. */


/*PUB jb_lload_3*/
/* Meaning: Load long integer from local variable with index 3. */


/*PUB jb_fload*/
/* Meaning: Load single float from local variable. */


/*PUB jb_fload_0*/
/* Meaning: Load single float from local variable with index 0. */


/*PUB jb_fload_1*/
/* Meaning: Load single float from local variable with index 1. */


/*PUB jb_fload_2*/
/* Meaning: Load single float from local variable with index 2. */


/*PUB jb_fload_3*/
/* Meaning: Load single float from local variable with index 3. */


/*PUB jb_dload*/
/* Meaning: Load double float from local variable. */


/*PUB jb_dload_0*/
/* Meaning: Load double float from local variable with index 0. */


/*PUB jb_dload_1*/
/* Meaning: Load double float from local variable with index 1. */


/*PUB jb_dload_2*/
/* Meaning: Load double float from local variable with index 2. */


/*PUB jb_dload_3*/
/* Meaning: Load double float from local variable with index 3. */


/*PUB jb_aload*/
/* Meaning: Load object reference from local variable. */


/*PUB jb_aload_0*/
/* Meaning: Load object reference from local variable with index 0. */


/*PUB jb_aload_1*/
/* Meaning: Load object reference from local variable with index 0. */


/*PUB jb_aload_2*/
/* Meaning: Load object reference from local variable with index 0. */


/*PUB jb_aload_3*/
/* Meaning: Load object reference from local variable with index 0. */


