/*
************************************************************
* File jvmStore: storing stack values into local variables *
************************************************************
*/


#include "jvmStack.h"
#include "jvmConvert.h"
#include "jvmData.h"
#include "jvmStore.h"
  
  
void jb_istore(void) {
  long fp,index,val;
/* Meaning: Store integer into local variable. */
/*
  JEM format: istore,byte1
  byte1 is the index of the local variable.
*/
  index = readJavaByte(getJvmPC()+1);
  val = pop();
  fp = getJvmFP();
  writeJavaIntBE(fp + (index<<1),val);
  incJvmPC(2);
}  

void jb_istore_0(void) {
  long fp,val;
/* Meaning: Store integer into local variable with index 0. */
/*
  JEM format: istore_0
*/
  val = pop();
  fp = getJvmFP();
  writeJavaIntBE(fp,val);
  incJvmPC(1);
}  

void jb_istore_1(void) {
  long fp,val;
/* Meaning: Store integer into local variable with index 1. */
/*
  JEM format: istore_1
*/
  val = pop();
  fp = getJvmFP();
  writeJavaIntBE(fp + 2,val);
  incJvmPC(1);
}

void jb_istore_2(void) {
  long fp,val;
/* Meaning: Store integer into local variable with index 2. */
/*
  JEM format: istore_2
*/
  val = pop();
  fp = getJvmFP();
  writeJavaIntBE(fp + 4,val);
  incJvmPC(1);
}

void jb_istore_3(void) {
  long fp,val;
/* Meaning: Store integer into local variable with index 3. */
/*
  JEM format: istore_3
*/
  val = pop();
  fp = getJvmFP();
  writeJavaIntBE(fp + 6,val);
  incJvmPC(1);
}

/*PUB jb_lstore*/
/* Meaning: Store long integer into local variable. */


/*PUB jb_lstore_0*/
/* Meaning: Store long integer into local variable with index 0. */


/*PUB jb_lstore_1*/
/* Meaning: Store long integer into local variable with index 1. */


/*PUB jb_lstore_2*/
/* Meaning: Store long integer into local variable with index 2. */


/*PUB jb_lstore_3*/
/* Meaning: Store long integer into local variable with index 3. */


/*PUB jb_fstore*/
/* Meaning: Store single float into local variable. */


/*PUB jb_fstore_0*/
/* Meaning: Store single float into local variable with index 0. */


/*PUB jb_fstore_1*/
/* Meaning: Store single float into local variable with index 1. */


/*PUB jb_fstore_2*/
/* Meaning: Store single float into local variable with index 2. */


/*PUB jb_fstore_3*/
/* Meaning: Store single float into local variable with index 3. */


/*PUB jb_dstore*/
/* Meaning: Store double-precision floating-point number into local variable. */


/*PUB jb_dstore_0*/
/* Meaning: Store double float into local variable with index 0. */


/*PUB jb_dstore_1*/
/* Meaning: Store double float into local variable with index 1. */


/*PUB jb_dstore_2*/
/* Meaning: Store double float into local variable with index 2. */


/*PUB jb_dstore_3*/
/* Meaning: Store double float into local variable with index 3. */


/*PUB jb_astore*/
/* Meaning: Store object reference into local variable. */


/*PUB jb_astore_0*/
/* Meaning: Store object reference into local variable with index 0. */


/*PUB jb_astore_1*/
/* Meaning: Store object reference into local variable with index 1. */


/*PUB jb_astore_2*/
/* Meaning: Store object reference into local variable with index 2. */


/*PUB jb_astore_3*/
/* Meaning: Store object reference into local variable with index 3. */


void jb_iinc(void) {
  long fp,index,val;
/* Meaning: Increment local variable by constant. */
/*
  JEM format: iinc,byte1,byte2
  byte1 is the index of the local variable. byte2 is the signed 1byte value to add to local variable.
*/
  index = readJavaByte(getJvmPC()+1);
  val = readJavaByte(getJvmPC()+2);
  val = b2i(val);
  fp = getJvmFP();
  val += readJavaIntBE(fp + (index<<1));
  writeJavaIntBE(fp + (index<<1),val);
  incJvmPC(3);
}
