/*
***************************************************
* File jvmVpQueue: VP queu (runs in seperate COG) *
***************************************************
*/

/*
  Virtual Peripherals are implemented as background code, meaning the code executes
  independantly from the interpreted java code.
*/

#include <propeller.h>
#include "jvmDefines.h"
#include "jvmVpQueue.h"

long vpBank;
  
void qStart(long vpRam) {
  long bank,slot,type,head,tail,buffer,count,data,hsMask,hsInvert,hsInput,len;
/* run queue routine in seperate cog */
  vpBank = vpRam;
  slot = 0;
  while (TRUE) {
    bank = slot*24 + vpBank;
    type = *(char *)(bank + nmPeriphISRVec);
    slot = (slot+1) % MAX_NUM_VPS;
    switch (type) {
      case UARTRX: //if received a byte, read value from receiver, and if queue not full enqueue value into queue
                   data = *(int *)(bank + nmUartDataH);
                   if (data > 255) {
                     *(int *)(bank + nmUartDataH) = data & 0xFF; //clear rxflag
                     head = *(char *)(bank + nmUartHead);
                     tail = *(char *)(bank + nmUartTail);
                     buffer = *(int *)(bank + nmUartBufferH);
                     len = (head-tail+256) % 256;
                     if (len < 255) {
                       *(char *)(buffer + head) = data;
                       *(char *)(bank + nmUartHead) = (head+1);
                     }
				   }
				   break; 
      case UARTTX: //if allowed to transmit, and queue not empty, dequeue value from queue and write to transmitter
                   count = *(char *)(bank + nmUartCount);
                   if (count == 0) {
                     head = *(char *)(bank + nmUartHead);
                     tail = *(char *)(bank + nmUartTail);
                     buffer = *(int *)(bank + nmUartBufferH);
                     if (head != tail) {
                       hsMask = *(long *)(bank + nmInmask);
                       if (hsMask != 0) {
                         hsInvert = *(char *)(bank + nmUartInvert) & 0x02;
                         hsInput = INA & hsMask;
                         if (hsInvert == 0x02)
                           hsInput ^= hsMask; //hsInput is 0 if handshake active (allowed to send)
                         hsMask = hsInput;
					   }
                       if (hsMask == 0) {  
                         data = *(char *)(buffer + tail);
                         *(char *)(bank + nmUartTail) = (tail+1);
                         data <<= 8;
                         data |= 0x80;
                         *(int *)(bank + nmUartDataH) = data;
                         count = *(char *)(bank + nmUartStopBits);
                         *(char *)(bank + nmUartCount) = count;
					   }
					 }
				   }
	  //default: 
    }
  }
}

  